# -*- coding:Utf-8 -
import es, popuplib
from os import path
from traceback import format_exception
from time import strftime

informations = es.AddonInfo()
informations.name = 'Traceback module'
informations.basename = 'tbck'
informations.version = '1.0'
informations.author = '@liVier'
informations.description = 'Tracebacks in popup'

es.ServerVar('tbck', '%s by %s' % (informations.version, informations.author), informations.description).makepublic()

LastTraceback = { 'value' : es.sys.exc_info() }
Events = [
'load', 'unload', 'disable', 'enable', 'player_team', 'player_class', 'player_death','player_hurt', 'player_chat', 
'player_score', 'player_spawn','player_shoot', 'player_use', 'player_changename', 'player_hintmessage','player_connect', 
'player_info', 'player_disconnect', 'player_activate','player_say', 'client_disconnect', 'map_start', 'scriptpack_register',
'scriptpack_unregister', 'player_validated', 'player_setting', 'client_command','player_chat', 'player_variable', 'player_jump', 
'client command', 'map_start', 'player_death', 'player_hurt', 'bomb_beginplant', 'bomb_abortplant', 'bomb_planted', 'bomb_defused', 
'bomb_exploded', 'bomb_dropped', 'bomb_pickup', 'bomb_begindefuse', 'bomb_abortdefuse', 'hostage_follows', 'hostage_hurt', 'hostage_killed', 
'hostage_rescued', 'hostage_stops_followin', 'hostage_rescued_all', 'hostage_call_for_help', 'vip_escaped', 'vip_killed', 'player_radio', 
'bomb_beep', 'weapon_fire', 'weapon_fire_on_empty', 'weapon_reload', 'weapon_zoom', 'item_pickup', 'grenade_bounce', 'hegrenade_detonate', 
'flashbang_detonate', 'smokegrenade_detonate', 'bullet_impact', 'player_footstep', 'player_jump', 'player_blind', 'player_falldamage', 
'door_moving', 'round_freeze_end', 'nav_blocked', 'nav_generate', 'player_stats_updated', 'spec_target_updated', 'cs_win_panel_round', 
'cs_win_panel_match', 'show_freezepanel', 'hide_freezepanel', 'freezecam_started', 'player_avenged_teammat', 'achievement_earned', 
'achievement_earned_loc', 'match_end_conditions', 'round_mvp', 'player_decal', 'teamplay_round_start'
]

def Excepter(type, value, traceback):
	if str(value) == str(LastTraceback['value'][1]):
		es.msg("#multi", "#lightgreen [TraceBack]#default %s" % str(value))
		popup = PopBug(type, value, traceback)
		popup.Update(str(value))
	else:
		es.msg("#multi", "#lightgreen [TraceBack]#default %s" % str(value))
		LastTraceback['value'] = (type, value, traceback)
		popup = PopBug(type, value, traceback)
		popup.Send()
				
es.sys.excepthook = Excepter

def TriggerEvent(ev):
	exc = es.sys.exc_info()
	if not None in exc:
		es.sys.excepthook(*exc)
		
def load():
	tb_Popup = popuplib.easymenu('tbcks', 'tb', pop_tracebacks)
	tb_Popup.settitle('Latest Traceback(s)')
	for event in Events:
		es.addons.registerForEvent(__import__(__name__), event, TriggerEvent)
		
def unload():
	try:
		popuplib.delete('tb_Popup')
		del EXCEPTS
	except:
		pass
	for event in Events:
		es.addons.unregisterForEvent(event, TriggerEvent)

def player_say(ev):
	userid = int(ev['userid'])
	if userid and ev['text'] == '!bugs':
		tb_Popup = popuplib.find('tbcks')
		tb_Popup.send(userid)
		for userid in es.getUseridList():
			tb_Popup.update(userid) 
	else:
		return
		
def GetExcept(name):
	return EXCEPTS[name]

def reshow(name, choice, userid):
	tb_Popup = popuplib.find('tbcks')
	tb_Popup.send(userid)
		
def pop_tracebacks(userid, choice, popupname):
	Popup = popuplib.create(str(userid))
	Popup.addline('Addon by @liVier (v1)')
	Popup.addline('********************')
	Popup.addline(' ')	
	for x in GetExcept(choice):
		Popup.addline(x[:-1])
	Popup.addline(' ')
	Popup.addline('********************')
	Popup.addline('->1. Back')
	Popup.select(1, reshow) 
	Popup.send(userid)
	Popup.delete()
	
def Write(date, tb):
	if path.isfile(es.getAddonPath('tbck') + '/logs.txt'):
		f = open(es.getAddonPath('tbck') + '/logs.txt', "a")
		f.write("\n%s\n" % date)
		for x in tb:
			f.write(x[:-1])
		f.write('\n\n')
	else:
		es.msg('plz, make a logs.txt in /tbck')
			
class PopBug:
	global EXCEPTS
	EXCEPTS = dict()
	def __init__(self, type, value, tb):
		self.name = str(value)
		self.e = format_exception(type, value, tb)
		EXCEPTS[self.name] = self.e
		self.date = strftime('%d/%m at %H:%M')
		
	def Send(self):
		Write(self.date, self.e)
		tb_Popup = popuplib.find('tbcks')
		tb_Popup.addoption(self.name, self.date)
		for userid in es.getUseridList():
			tb_Popup.update(userid)
			
	def Update(self, name):
		Write(self.date, self.e)
		tb_Popup = popuplib.find('tbcks')
		tb_Popup.setoption(name, text=self.date)
		for userid in es.getUseridList():
			tb_Popup.update(userid)
			